Bug 33978 - Support for UEFI
Support for UEFI
Status: CLOSED FIXED
Product: Univention Corporate Client (UCC)
Classification: Unclassified
Component: General
unspecified
Other Linux
: P5 enhancement
: UCC 2.0
Assigned To: Janek Walkenhorst
Felix Botner
: interim-3
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2014-01-23 11:15 CET by Moritz Muehlenhoff
Modified: 2014-06-12 09:20 CEST (History)
0 users

See Also:
What kind of report is it?: ---
What type of bug is this?: ---
Who will be affected by this bug?: ---
How will those affected feel about the bug?: ---
User Pain:
Enterprise Customer affected?:
School Customer affected?:
ISV affected?:
Waiting Support:
Ticket number:
Bug group (optional):
Max CVSS v3 score:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Moritz Muehlenhoff univentionstaff 2014-01-23 11:15:09 CET
UCC should support UEFI out of the box, e.g. the rollout should create a EFI system partition and Grub needs to be modified to using Grub's EFI support. It should be possible to create a unified partition scheme which works with both EFI and BIOS.

UEFI rollouts using PXE need to be evaluated.
Comment 1 Janek Walkenhorst univentionstaff 2014-04-08 13:03:12 CEST
* BIOS-MBR (Current situation)
Partition table: MBR
GRUB as bootloader
 stored in MBR and unpartitioned area behind MBR
Booted by BIOS via MBR

* BIOS-GPT
Partition table: GPT
 Special partition "BIOS boot partition"
GRUB as bootloader
 stored in MBR and "BIOS boot partition"
Booted by BIOS via MBR

* UEFI-GPT
Parition table: GPT
 Special partition "EFI System partition"
  FAT32
GRUB as bootloader
 stored in "EFI System partition"
Booted by UEFI


It should be possible to combine BIOS-GPT and UEFI-GPT by having both a BIOS boot partition and and EFI System partition. But this will probably lead to problems with different firmwares.

For simplicity it might be best to change from BIOS-MBR to BIOS-GPT and have an image configuration to select between BIOS-GPT and UEFI-GPT.
Comment 2 Janek Walkenhorst univentionstaff 2014-04-08 13:28:49 CEST
(In reply to Janek Walkenhorst from comment #1)
> * BIOS-MBR (Current situation)
> * BIOS-GPT
> For simplicity it might be best to change from BIOS-MBR to BIOS-GPT
UCC images are already using BIOS-GPT.
Comment 3 Janek Walkenhorst univentionstaff 2014-04-11 15:20:42 CEST
UEFI PXE boot works by changing the univentionDhcpBootFilename to point to an EFI image.
The image can be created for example from a boot CD image like so:
grub-mkimage --format=x86_64-efi --memdisk mini.iso --output=/var/lib/univention-client-boot/grubx64.efi $(find /usr/lib/grub/x86_64-efi/ -type f -name \*.mod -printf '%f\n'|cut -d. -f1)
Comment 4 Moritz Muehlenhoff univentionstaff 2014-05-15 10:37:43 CEST
Hardware support for UEFI/PXE is currently in early stages (of three types if UEFI-capable systems only one supported PXE boot and only after an update of the UEFI firmware.

For now we'll ship a UEFI image configuration which can be used to build an UEFI image. At a later stage an official UEFI image can be provided.
Comment 5 Janek Walkenhorst univentionstaff 2014-05-16 15:17:25 CEST
The package ucc-pxe-boot now contains the files
 /var/lib/univention-client-boot/ldlinux.e32
 /var/lib/univention-client-boot/ldlinux.e64
 /var/lib/univention-client-boot/syslinux.efi32
 /var/lib/univention-client-boot/syslinux.efi64
to enable UEFI-PXE booting by selecting the syslinux.efi64 (or syslinux.efi32) as the "boot_filename" (policies/dhcp_boot).

The package ucc-image-toolkit now contains the file
 /usr/share/doc/ucc-image-toolkit/example/ucc-desktop-efi.cfg
as an example configuration for UEFI partitioning.
The required changes are having an EFI system partition:
 partition2_name: boot
 partition2_size: 500
 partition2_fs: esp
 partition2_mountpoint: /boot/efi
 partition2_image_mount: true
 partition2_copy_files: false
and having the corresponding GRUB modules available:
 grub-efi-amd64-bin
 grub-efi-ia32-bin
.

The package univention-ucc-initramfs' file
 initramfs-tools/scripts/ucc
now detects "esp" partitions and correctly formats them. Also GRUB is installed for the correct UEFI-architecture if an ESP is detected.
Comment 6 Felix Botner univentionstaff 2014-05-22 11:43:55 CEST
FAIL - Changelog

OK (local boot on "UEFI system" does not work, probably a hardware issue)
Comment 7 Janek Walkenhorst univentionstaff 2014-05-22 15:08:39 CEST
(In reply to Felix Botner from comment #6)
> FAIL - Changelog
Added.
Comment 8 Felix Botner univentionstaff 2014-05-23 09:05:43 CEST
OK
Comment 9 Moritz Muehlenhoff univentionstaff 2014-06-12 09:20:10 CEST
UCC 2.0 has been released:
 http://docs.univention.de/release-notes-ucc-2.0.html

If this error occurs again, please use "Clone This Bug".